//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <vector>
using namespace std;
#include "SubAccount.h"
#include "Account.h"
#include <math.h>

//---------------------------------------------------------------------------

#pragma package(smart_init)


CAccount::CAccount()
{
    MinAbs=20;
    MinPercent=0.02;
}

CAccount::~CAccount()
{
    for (unsigned int i=0;i<subs.size();i++)
        delete subs[i];
}

double CAccount::GetBalance()
{
    double balance=0;
    for (unsigned int i=0;i<subs.size();i++)
        balance+=subs[i]->GetBalance();
    return Round(balance);
}

double CAccount::GetInterest()
{
    double total=0;
    for (unsigned int i=0;i<subs.size();i++)
        total+=subs[i]->GetInterest();
    return total;
}

double CAccount::GetMaxRate()
{
    double rate=0;
    double tmp;
    for (unsigned int i=0;i<subs.size();i++)
    {
        tmp=subs[i]->GetRate();
        if (tmp>rate)
            rate=tmp;
    }
    return rate;
}

double CAccount::GetMinPayment()
{
    double payment,balance;
    balance=GetBalance();
    if (balance<=0)
        return 0;
    payment=balance*MinPercent;
    if (payment<MinAbs)
        payment=MinAbs;

    if (payment!=floor(payment))
        payment=floor(payment)+1;
    return payment;
}

double CAccount::MakePayment(double amt)
{
    double payment=amt-GetInterest();
    for (unsigned int i=0;i<subs.size();i++)
    {
        if (payment<=0)
            break;
        payment=subs[i]->MakePayment(payment);
    }
    return Round(payment);
}

double inline CAccount::Round(double x, int n)
{
    double mult=pow10(n);
    double y=mult*x;
    y=floor(y+.5);
    y=y/mult;
    return y;
}

String CAccount::GetName()
{
    return name;
}

CAccount* CAccount::Clone()
{
    CAccount *ptr=new CAccount();
    ptr->MinAbs=MinAbs;
    ptr->MinPercent=MinPercent;
    ptr->name=name;
    for (unsigned int i=0;i<subs.size();i++)
        ptr->subs.push_back(subs[i]->Clone());
    return ptr;
}