//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <vector>
using namespace std;
#include "SubAccount.h"
#include "Account.h"
#include "ActForm.h"
#include "SubActForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAccountForm *AccountForm;
//---------------------------------------------------------------------------
__fastcall TAccountForm::TAccountForm(TComponent* Owner)
    : TForm(Owner)
{
    account=NULL;
    UpdateGrid();
}
//---------------------------------------------------------------------------

void TAccountForm::UpdateGrid()
{
    DataGrid->Cells[0][0]="Balance";
    DataGrid->Cells[1][0]="Rate 1";
    DataGrid->Cells[2][0]="Rate 2";
    DataGrid->Cells[3][0]="Date";

    if (account)
    {
        if (account->subs.size()>0)
        {
            DataGrid->RowCount=account->subs.size()+1;
            for (unsigned int i=0;i<account->subs.size();i++)
            {
                DataGrid->Cells[0][i+1]=account->subs[i]->GetBalance();
                DataGrid->Cells[1][i+1]=account->subs[i]->first_rate;
                DataGrid->Cells[2][i+1]=account->subs[i]->second_rate;
                TDateTime t=account->subs[i]->change;
                if ((double)t==0)
                    DataGrid->Cells[3][i+1]="Never";
                else
                    DataGrid->Cells[3][i+1]=t.FormatString("mmm yyyy");
            }
        }
        else
        {
            DataGrid->RowCount=2;
            DataGrid->Cells[0][1]="";
            DataGrid->Cells[1][1]="";
            DataGrid->Cells[2][1]="";
            DataGrid->Cells[3][1]="";
        }
    }
    else
    {
        DataGrid->Cells[0][1]="";
        DataGrid->Cells[1][1]="";
        DataGrid->Cells[2][1]="";
        DataGrid->Cells[3][1]="";
    }
}

CAccount* TAccountForm::EditAccount(CAccount *act)
{
    if (act==NULL)
        account=new CAccount();
    else
        account=act->Clone();

    NameEdit->Text=account->name;
    if (account->name.Length()>0)
        Caption="Account - "+account->name;
    else
        Caption="Account";
    MinAbsEdit->Text=account->MinAbs;
    MinPerEdit->Text=account->MinPercent*100;

    UpdateGrid();
    ShowModal();

    if (ModalResult!=mrOk)
    {
        delete account;
        account=NULL;
    }

    return account;
}

void __fastcall TAccountForm::OKButtonClick(TObject *Sender)
{
    ModalResult=mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAccountForm::CancelButtonClick(TObject *Sender)
{
    ModalResult=mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TAccountForm::AddButtonClick(TObject *Sender)
{
    CSubAccount *ptr=NULL;
    ptr=SubAccountForm->EditSubAccount(NULL);

    if (ptr)
    {
        account->subs.push_back(ptr);
        UpdateGrid();
    }

}
//---------------------------------------------------------------------------


void __fastcall TAccountForm::NameEditChange(TObject *Sender)
{
    if (NameEdit->Modified)
    {
        account->name=NameEdit->Text;
        if (account->name.Length()>0)
            Caption="Account - "+account->name;
        else
            Caption="Account";
    }
}
//---------------------------------------------------------------------------

void __fastcall TAccountForm::MinAbsEditChange(TObject *Sender)
{
    if (MinAbsEdit->Modified)
    {
        try
        {
            account->MinAbs=MinAbsEdit->Text.ToDouble();
        }
        catch (EConvertError *e)
        {
            account->MinAbs=0;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TAccountForm::MinPerEditChange(TObject *Sender)
{
    if (MinPerEdit->Modified)
    {
        try
        {
            account->MinPercent=MinPerEdit->Text.ToDouble()/100;
        }
        catch (EConvertError *e)
        {
            account->MinPercent=0;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TAccountForm::DoGridDblClick(TObject *Sender)
{
    unsigned int n=DataGrid->Row;
    if (n==0 || n>(account->subs.size()))
        return;
    CSubAccount *ptr=account->subs[n-1];
    ptr=SubAccountForm->EditSubAccount(ptr);
    if (ptr)
    {
        CSubAccount *tmp=account->subs[n-1];
        account->subs[n-1]=ptr;
        UpdateGrid();
        delete tmp;
    }
}
//---------------------------------------------------------------------------

void __fastcall TAccountForm::DeleteSubaccountClick(TObject *Sender)
{
    unsigned int n=DataGrid->Row;
    if (n==0 || n>(account->subs.size()))
        return;
    vector<CSubAccount*>::iterator iter=account->subs.begin();
    iter+=n-1;
    CSubAccount *ptr=account->subs[n-1];
    account->subs.erase(iter);
    delete ptr;
    UpdateGrid();
}
//---------------------------------------------------------------------------


