//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SubAccount.h"
#include <math.h>

//---------------------------------------------------------------------------

#pragma package(smart_init)


CSubAccount::CSubAccount()
{
    current=current.CurrentDate();
    balance=first_rate=second_rate=0;
}

CSubAccount::~CSubAccount()
{
    //TODO: Add your source code here
}

double CSubAccount::GetBalance()
{
    return balance;
}

double CSubAccount::GetRate()
{
    if (current<change || (double)change==0)
        return first_rate;
    else
        return second_rate;
}

double CSubAccount::MakePayment(double amt)
{
    balance-=amt;
    AdvanceMonth();
    double tmp=0;
    if (balance<0)
    {
        tmp=Round(-balance);
        balance=0;
    }
    return tmp;
}

double CSubAccount::GetInterest()
{
    double rate=GetRate()/12;
    return Round(balance*rate);
}

double inline CSubAccount::Round(double x, int n)
{
    double mult=pow10(n);
    double y=mult*x;
    y=floor(y+.5);
    y=y/mult;
    return y;
}

inline void CSubAccount::AdvanceMonth()
{
    unsigned short year,month,day;
    current.DecodeDate(&year,&month,&day);
    if (month<12)
        current=EncodeDate(year,month+1,day);
    else
        current=EncodeDate(year+1,1,day);
}

CSubAccount* CSubAccount::Clone()
{
    CSubAccount *ptr=new CSubAccount();

    ptr->balance=balance;
    ptr->first_rate=first_rate;
    ptr->second_rate=second_rate;
    ptr->change=change;
    ptr->current=current;
    return ptr;
}
