//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SubAccount.h"
#include "SubActForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSubAccountForm *SubAccountForm;
//---------------------------------------------------------------------------
__fastcall TSubAccountForm::TSubAccountForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TSubAccountForm::OKButtonClick(TObject *Sender)
{
    ModalResult=mrOk;    
}
//---------------------------------------------------------------------------
void __fastcall TSubAccountForm::CancelButtonClick(TObject *Sender)
{
    ModalResult=mrCancel;    
}
//---------------------------------------------------------------------------

CSubAccount* TSubAccountForm::EditSubAccount(CSubAccount *sub)
{
    if (sub==NULL)
        subaccount=new CSubAccount();
    else
        subaccount=sub->Clone();

    BalanceEdit->Text=subaccount->balance;
    StartEdit->Text=subaccount->first_rate*100;
    EndEdit->Text=subaccount->second_rate*100;
    if ((double)subaccount->change==0)
        ChangeDate->Date=subaccount->current;
    else
        ChangeDate->Date=subaccount->change;
    ShowModal();

    unsigned short y1,m1,d1;
    unsigned short y2,m2,d2;
    subaccount->change.DecodeDate(&y1,&m1,&d1);
    subaccount->current.DecodeDate(&y2,&m2,&d2);
    if (y1==y2 && m1==m2)
        subaccount->change=0;
    else if ((y1<y2) || (y1==y2 && m1<m2))
        subaccount->change=0;

    if (ModalResult!=mrOk)
    {
        delete subaccount;
        subaccount=NULL;
    }
    return subaccount;
}
//---------------------------------------------------------------------------

double TSubAccountForm::EditToDouble(TEdit *edit, double def)
{
    double x;
    try
    {
        x=edit->Text.ToDouble();
    }
    catch (EConvertError *e)
    {
        x=def;
    }
    return x;
}
//---------------------------------------------------------------------------

void __fastcall TSubAccountForm::BalanceEditChange(TObject *Sender)
{
    if (BalanceEdit->Modified)
        subaccount->balance=EditToDouble(BalanceEdit);
}
//---------------------------------------------------------------------------

void __fastcall TSubAccountForm::StartEditChange(TObject *Sender)
{
    if (StartEdit->Modified)
        subaccount->first_rate=EditToDouble(StartEdit)/100;
}
//---------------------------------------------------------------------------

void __fastcall TSubAccountForm::EndEditChange(TObject *Sender)
{
    if (EndEdit->Modified)
        subaccount->second_rate=EditToDouble(EndEdit)/100;
}
//---------------------------------------------------------------------------

void __fastcall TSubAccountForm::DoDateChange(TObject *Sender)
{
    subaccount->change=ChangeDate->Date;
}
//---------------------------------------------------------------------------

